use hyper;
use hyper::header::Header;


/// [unstable] A response which contains all information to construct
pub struct Response {
    raw: hyper::Response,
}

impl Response {
    pub fn from_raw(raw: hyper::Response) -> Self {
        Response { raw }
    }

    pub fn into_raw(self) -> hyper::Response {
        self.raw
    }

    pub fn new() -> Self {
        Response { raw: hyper::Response::new() }
    }

    pub fn with_status(self, status: hyper::StatusCode) -> Self {
        Response { raw: self.raw.with_status(status) }
    }

    pub fn with_header<H: Header>(self, header: H) -> Self {
        Response { raw: self.raw.with_header(header) }
    }

    pub fn with_body<B: Into<hyper::Body>>(self, body: B) -> Self {
        Response { raw: self.raw.with_body(body) }
    }
}
